(function () {
    'use strict';

    angular
        .module('app.controllers')
        .controller('ArticleDetailCtrl', ['$location', 'UtilsService', 'article', ArticleDetailCtrl]);

    function ArticleDetailCtrl($location, UtilsService, article) {
        console.log('Controller: ArticleDetailCtrl');

        if(!article) {
            $location.path('/app/error').replace();
            console.log('Article is null');
            return;
        }

        var vm = this;
        vm.id = article.id;
        vm.sections = [];

        vm.title = article.title;
        vm.summary = article.summary;
        vm.thumb = article.thumb;
        vm.open = open;
        vm.sections = article.sections;

        // Adds addition parameters to all sections.
        for (var i = 0; i < vm.sections.length; i++) {
            vm.sections[i].index = i;
            vm.sections[i].expanded = false;
        }

        return vm;

        function open(url) {
            console.log('Opening url...');
            url = decodeURIComponent(url);
            UtilsService.openExternalUrl(url);
        }
    }
})();
