(function () {
    'use strict';

    angular
        .module('app.controllers')
        .controller('ImageListCtrl', ['$scope', '$timeout', '$state', 'items', ImageListCtrl]);

    function ImageListCtrl($scope, $timeout, $state, items) {
        console.log('Controller: ImageListCtrl');

        var vm = this;

        // Numbers to load at once
        var itemsNumber = 10;

        vm.items = setIds(items);
        vm.images = vm.items.slice(0, itemsNumber);
        vm.next = next;
        vm.openUrl = openUrl;

        $scope.$on('DONE', function() {
            console.log('loading = false');
            $scope.$apply(function(){
                vm.loading = false;
            });
        });

        return vm;

        function next() {
            $scope.$apply(function() {
                vm.loading = true;
            });
            $timeout(function () {
                itemsNumber += 10;
                vm.images = vm.items.slice(0, itemsNumber);
                $scope.$emit('loaded');
            }, 0, false);
        }

        function setIds(items) {
            for (var i = 0; i < items.length; i++) {
                items[i].id = i;
            }
            return items;
        }

        function openUrl(src, id) {
            sessionStorage.imgUrl = src;
            sessionStorage.imgId = id;
            $state.go('app.image');
        }
    }

})();