/* Controllers module */

(function () {
    'use strict';

    angular
        .module('app.controllers', [])
        .controller('MainCtrl', ['$rootScope', '$window', '$templateCache', 'UtilsService', MainCtrl]);

    function MainCtrl($rootScope, $window, $templateCache, UtilsService) {

        $rootScope.$on("$stateChangeStart", function (event, toState) {
            $rootScope.loading = true;
            ga('send', {
                'hitType': 'pageview',
                'page': toState.url,
                'title': toState.name
            });
        });

        $rootScope.$on("$viewContentLoaded", function () {
            $rootScope.loading = false;
            // Needs for showing spinner during loading
            $templateCache.removeAll();
        });

        $rootScope.back = function () {
            $window.history.back();
            sessionStorage.pinchZoomActive = false;
        };

        $rootScope.font = window.localStorage.font || '16px';

        // Changes theme from default (dark) if local storage contains saved information
        if(window.localStorage.darkTheme === "false") {
            UtilsService.changeTheme();
        }
    }

})();