(function () {
    'use strict';

    angular
        .module('app.controllers')
        .controller('NavBarCtrl', ['$scope', '$timeout', 'ConfigService', NavBarCtrl]);

    function NavBarCtrl($scope, $timeout, ConfigService) {
        console.log('Controller: NavBarCtrl');

        var vm = this;
        vm.isSearchActive = false;
        vm.tempTitle = ConfigService.get().title;

        $scope.$on("$stateChangeStart", function(){
            vm.isSearchActive = false;
        });

        $scope.$watch('nav.isSearchActive', function(newVal, oldVal){
            if (newVal === true){
                $timeout(function(){
                    var input = angular.element(document.querySelector("#top-nav-bar-search"));
                    input.focus();
                }, 0, false);
            }
        });

        return vm;
    }

})();