(function () {
    'use strict';

    angular
        .module('app.controllers')
        .controller('SettingsCtrl', ['$rootScope', 'UtilsService', 'ConfigService', SettingsCtrl]);

    function SettingsCtrl($rootScope, UtilsService, ConfigService) {
        console.log('Controller: SettingsCtrl');
        var minFontSize = 12;
        var maxFontSize = 22;

        var vm = this;

        vm.config = ConfigService.get();
        vm.rateApp = rateApp;
        vm.email = email;
        vm.changeTheme = UtilsService.changeTheme;
        vm.increaseFont = increaseFont;
        vm.decreaseFont = decreaseFont;

        return vm;

        function rateApp() {
            ga('send', 'event', 'button', 'click', 'rate app');
            UtilsService.openExternalUrl(vm.config.googlePlayUrl);
        }

        function email() {
            ga('send', 'event', 'button', 'click', 'send feedback from settings');
            window.location.href = 'mailto:' + vm.config.email + "?subject=Feedback";
        }

        function increaseFont() {
            var percentStr = $rootScope.font.replace('px', '');
            var fontSize = parseInt(percentStr);
            if (fontSize < maxFontSize) {
                $rootScope.font = ((fontSize + 2) + 'px');
            }
            window.localStorage.font = $rootScope.font;
            ga('send', 'event', 'button', 'click', 'increase font');
        }

        function decreaseFont() {
            var percentStr = $rootScope.font.replace('px', '');
            var fontSize = parseInt(percentStr);
            if (fontSize > minFontSize) {
                $rootScope.font = ((fontSize - 2) + 'px');
            }
            window.localStorage.font = $rootScope.font;
            ga('send', 'event', 'button', 'click', 'decrease font');
        }

    }
})();