(function () {
    'use strict';

    angular
        .module('app.controllers')
        .controller('VideoListCtrl', ['$scope', '$timeout', 'items', 'UtilsService', VideoListCtrl]);

    function VideoListCtrl($scope, $timeout, items, UtilsService) {
        console.log('Controller: VideoListCtrl');

        var vm = this;

        // Numbers to load at once
        var itemsNumber = 10;

        vm.items = items;
        vm.videos = vm.items.slice(0, itemsNumber);
        vm.play = play;
        vm.next = next;

        $scope.$on('DONE', function() {
            console.log('loading = false');
            $scope.$apply(function(){
                vm.loading = false;
            });
        });

        return vm;

        function play(id) {
            console.log('Opening video...');
            var url = 'http://www.youtube.com/watch?v=' + id;

            UtilsService.openExternalUrl(url);
        }

        function next() {
            $scope.$apply(function() {
                vm.loading = true;
            });
            $timeout(function () {
                itemsNumber += 10;
                vm.videos = vm.items.slice(0, itemsNumber);
                $scope.$emit('loaded');
            }, 0, false);
        }
    }

})();