(function () {
    'use strict';

    angular
        .module('app.directives')
        .directive('addToFavourites', addToFavourites);

    function addToFavourites(FavouritesService) {
        var directive = {
            restrict: 'E',
            link: function (scope, elem) {
                console.log('Directive: addToFavourites');

                elem.parent().addClass('btn');
                
                var icon = elem.find('i');
                var favourite = {
                    id: scope.vm.id,
                    title: scope.vm.title,
                    type: 'page'
                };

                if (FavouritesService.isExist(favourite.id)) {
                    icon.addClass('icon-gold');
                }

                elem.bind('click', function () {
                    if (FavouritesService.isExist(favourite.id)) {
                        icon.removeClass('icon-gold');
                        FavouritesService.remove(favourite);
                        ga('send', 'event', 'button', 'click', 'remove from favourites');
                    }
                    else {
                        icon.addClass('icon-gold');
                        FavouritesService.put(favourite);
                        ga('send', 'event', 'button', 'click', 'add to favourites');
                    }
                });
            },
            templateUrl: 'views/directives/add-to-favourites.html'
        };
        return directive;
    }

})();