(function () {
    'use strict';

    angular
        .module('app.directives')
        .directive('lazyList', lazyList);

    function lazyList() {
        var directive = {
            restrict: 'A',
            link: function (scope, elem, attrs) {
                console.log('Directive: lazyList');

                $(elem).scroll(function () {
                    var position = Math.round($(this)[0].scrollHeight - $(this).scrollTop());
                    var dispersion = Math.abs(position - $(this).outerHeight());

                    if (dispersion < 10) {
                        var props = attrs.next ? attrs.next.split('.') : null;
                        if (props) {
                            var func = scope[props[0]];

                            for (var i = 1; i < props.length; i++) {
                                func = func[props[i]];
                            }
                            // Rise required action
                            func();
                        }
                    }
                });

                if (attrs.loadedEvent) {
                    scope.$on(attrs.loadedEvent, function (e) {
                        scope.$emit('DONE');
                    });
                }
            }
        };
        return directive;
    }

})();