(function () {
    'use strict';

    angular
        .module('app.services')
        .factory('ArticleService', ['ResourcesService', ArticleService]);

    function ArticleService(ResourcesService) {
        var tag = 'Service: ArticleService ->';

        var service = {
            getById: getById,
            getRandom: getRandom
        };
        return service;

        function getById(id) {
            console.log('%s getById(%s)', tag, id);

            var article = ResourcesService.getArticle(id);

            return article;
        }

        function getRandom() {
            var items = ResourcesService.getSearchList();
            var rawArticle = tryGetRandom(items);
            var article = getById(rawArticle.id);
            sessionStorage.randomArticleId = rawArticle.id;
            return article;
        }

        function tryGetRandom(items) {
            var article = items[Math.floor(Math.random()*items.length)];
            if(article.type == "page") {
                return article;
            } else {
                return tryGetRandom(items);
            }
        }
    }

})();