(function () {
    'use strict';

    angular
        .module('app.services')
        .factory('FavouritesService', [FavouritesService]);

    function FavouritesService() {
        var tag = 'Service: FavouritesService ->';
        var key = "favourites";

        var favourites = [];
        if (window.localStorage.getItem(key)) {
            favourites = JSON.parse(window.localStorage.getItem(key));
        }

        var service = {
            list: list,
            put: put,
            remove: remove,
            isExist: isExist
        };
        return service;


        function list() {
            console.log('%s list()', tag);

            return favourites;
        }

        function put(data) {
            console.log('%s put(%s)', tag, JSON.stringify(data));

            favourites.unshift(data);
            window.localStorage.setItem(key, JSON.stringify(favourites));
        }

        function remove(favourite) {
            for (var i = 0; i < favourites.length; i++) {
                if (favourites[i].id == favourite.id) {
                    favourites.splice(i, 1);
                }
            }
            window.localStorage.setItem(key, JSON.stringify(favourites));
        }

        function isExist(id) {
            for (var i = 0; i < favourites.length; i++) {
                if (favourites[i].id == id) {
                    return true;
                }
            }
            return false;
        }
    }

})();