(function () {
    'use strict';

    angular
        .module('app.services')
        .factory('SearchService', ['ResourcesService', SearchService]);

    function SearchService(ResourcesService) {
        // Store last search results
        var lastSearch = {
            query: '',
            result: []
        };

        var service = {
            search: search
            // TODO: implement search in context
        };
        return service;

        // Search items that satisfy user's query.
        // Case insensitive search.
        // @query - user's query
        // @amount - maximum items' count that satisfy the query
        // Return items
        function search(query, amount) {
            console.log('SearchService: Search(%s)', query);

            var result;
            var returnObj;

            if (query !== lastSearch.query) {
                result = ResourcesService.getSearchList()
                    .filter(function (pair) {
                        // Check if title meets user's request
                        return pair.title.toLowerCase().indexOf(query.toLowerCase()) > -1;
                    });
                lastSearch = {query: query, result: result};
            }
            else {
                result = lastSearch.result;
            }

            if (amount !== "infinity") {
                returnObj = result.slice(0, amount);
                returnObj.showMore = result.length > amount;
            } else {
                returnObj = result;
                returnObj.showMore = false;
            }

            return returnObj;
        }
    }
})();